diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-frame-exchange-manager.h ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.h
--- ns-3.42/src/wifi/model/eht/eht-frame-exchange-manager.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-frame-exchange-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -28,10 +17,55 @@
 namespace ns3
 {
 
+/// aRxPHYStartDelay value to use when waiting for a new frame in the context of EMLSR operations
+/// (Sec. 35.3.17 of 802.11be D3.1)
+extern const Time EMLSR_RX_PHY_START_DELAY;
+
 class MgtEmlOmn;
 
 /**
  * \ingroup wifi
+ * Reasons for an EMLSR client to drop an ICF
+ */
+enum class WifiIcfDrop : uint8_t
+{
+    USING_OTHER_LINK = 0,   // another EMLSR link is being used
+    NOT_ENOUGH_TIME_TX,     // not enough time for the main PHY to switch (because in TX state)
+    NOT_ENOUGH_TIME_RX,     // not enough time for the main PHY to switch (because in RX state)
+    NOT_ENOUGH_TIME_SWITCH, // not enough time for the main PHY to switch (already switching)
+    NOT_ENOUGH_TIME_SLEEP,  // not enough time for the main PHY to switch (because in SLEEP state)
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param reason the reason for dropping the ICF
+ * \returns a reference to the stream
+ */
+inline std::ostream&
+operator<<(std::ostream& os, WifiIcfDrop reason)
+{
+    switch (reason)
+    {
+    case WifiIcfDrop::USING_OTHER_LINK:
+        return (os << "USING_OTHER_LINK");
+    case WifiIcfDrop::NOT_ENOUGH_TIME_TX:
+        return (os << "NOT_ENOUGH_TIME_TX");
+    case WifiIcfDrop::NOT_ENOUGH_TIME_RX:
+        return (os << "NOT_ENOUGH_TIME_RX");
+    case WifiIcfDrop::NOT_ENOUGH_TIME_SWITCH:
+        return (os << "NOT_ENOUGH_TIME_SWITCH");
+    case WifiIcfDrop::NOT_ENOUGH_TIME_SLEEP:
+        return (os << "NOT_ENOUGH_TIME_SLEEP");
+    default:
+        NS_FATAL_ERROR("Unknown wifi ICF drop reason");
+        return (os << "UNKNOWN");
+    }
+}
+
+/**
+ * \ingroup wifi
  *
  * EhtFrameExchangeManager handles the frame exchange sequences
  * for EHT stations.
@@ -49,7 +83,7 @@
 
     void SetLinkId(uint8_t linkId) override;
     Ptr<WifiMpdu> CreateAliasIfNeeded(Ptr<WifiMpdu> mpdu) const override;
-    bool StartTransmission(Ptr<Txop> edca, uint16_t allowedWidth) override;
+    bool StartTransmission(Ptr<Txop> edca, MHz_u allowedWidth) override;
 
     /**
      * Send an EML Operating Mode Notification frame to the given station.
@@ -60,15 +94,14 @@
     void SendEmlOmn(const Mac48Address& dest, const MgtEmlOmn& frame);
 
     /**
-     * Get the RSSI (in dBm) of the most recent packet received from the station having
-     * the given address. If there is no such information for the given station and the
-     * station is affiliated with an MLD, return the RSSI (in dBm) of the most recent
-     * packet received from another station of the same MLD.
+     * Get the RSSI of the most recent packet received from the station having the given address. If
+     * there is no such information for the given station and the station is affiliated with an MLD,
+     * return the RSSI of the most recent packet received from another station of the same MLD.
      *
      * \param address of the remote station
-     * \return the RSSI (in dBm) of the most recent packet received from the remote station
+     * \return the RSSI of the most recent packet received from the remote station
      */
-    std::optional<double> GetMostRecentRssi(const Mac48Address& address) const override;
+    std::optional<dBm_u> GetMostRecentRssi(const Mac48Address& address) const override;
 
     /**
      * \param psdu the given PSDU
@@ -97,6 +130,40 @@
      */
     bool UsingOtherEmlsrLink() const;
 
+    /**
+     * Check if the frame received (or being received) is sent by an EMLSR client to start an
+     * UL TXOP. If so, take the appropriate actions (e.g., block transmission to the EMLSR client
+     * on the other links). This method is intended to be called when an MPDU (possibly within
+     * an A-MPDU) is received or when the reception of the MAC header in an MPDU is notified.
+     *
+     * \param hdr the MAC header of the received (or being received) MPDU
+     * \param txVector the TXVECTOR used to transmit the frame received (or being received)
+     * \return whether the frame received (or being received) is sent by an EMLSR client to start
+     *         an UL TXOP
+     */
+    bool CheckEmlsrClientStartingTxop(const WifiMacHeader& hdr, const WifiTxVector& txVector);
+
+    /**
+     * This method is intended to be called when an AP MLD detects that an EMLSR client previously
+     * involved in the current TXOP will start waiting for the transition delay interval (to switch
+     * back to listening operation) after the given delay.
+     * This method blocks the transmissions on all the EMLSR links of the given EMLSR client until
+     * the transition delay advertised by the EMLSR client expires.
+     *
+     * \param address the link MAC address of the given EMLSR client
+     * \param delay the given delay
+     */
+    void EmlsrSwitchToListening(const Mac48Address& address, const Time& delay);
+
+    /**
+     * \return a reference to the event indicating the possible end of the current TXOP (of
+     *         which this device is not the holder)
+     */
+    EventId& GetOngoingTxopEndEvent();
+
+    /// ICF drop reason traced callback (WifiMac exposes this trace source)
+    TracedCallback<WifiIcfDrop, uint8_t> m_icfDropCallback;
+
   protected:
     void DoDispose() override;
     void RxStartIndication(WifiTxVector txVector, Time psduDuration) override;
@@ -119,32 +186,24 @@
     void NavResetTimeout() override;
     void IntraBssNavResetTimeout() override;
     void SendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiMode rtsTxMode, double rtsSnr) override;
+    void PsduRxError(Ptr<const WifiPsdu> psdu) override;
 
+  private:
     /**
-     * This method is intended to be called when an AP MLD detects that an EMLSR client previously
-     * involved in the current TXOP will start waiting for the transition delay interval (to switch
-     * back to listening operation) after the given delay.
-     * This method blocks the transmissions on all the EMLSR links of the given EMLSR client until
-     * the transition delay advertised by the EMLSR client expires.
-     *
-     * \param address the link MAC address of the given EMLSR client
-     * \param delay the given delay
+     * \return whether the received ICF must be dropped because we are unable to process it
+     *         (e.g., another EMLSR link is being used or there is no time for main PHY switch)
      */
-    void EmlsrSwitchToListening(const Mac48Address& address, const Time& delay);
+    bool DropReceivedIcf();
 
-  private:
     /**
-     * Check if the frame received (or being received) is sent by an EMLSR client to start an
-     * UL TXOP. If so, take the appropriate actions (e.g., block transmission to the EMLSR client
-     * on the other links). This method is intended to be called when an MPDU (possibly within
-     * an A-MPDU) is received or when the reception of the MAC header in an MPDU is notified.
+     * Generate an in-device interference of the given power on the given link for the given
+     * duration.
      *
-     * \param hdr the MAC header of the received (or being received) MPDU
-     * \param txVector the TXVECTOR used to transmit the frame received (or being received)
-     * \return whether the frame received (or being received) is sent by an EMLSR client to start
-     *         an UL TXOP
+     * \param linkId the ID of the link on which in-device interference is generated
+     * \param duration the duration of the in-device interference
+     * \param txPower the TX power
      */
-    bool CheckEmlsrClientStartingTxop(const WifiMacHeader& hdr, const WifiTxVector& txVector);
+    void GenerateInDeviceInterference(uint8_t linkId, Time duration, Watt_u txPower);
 
     /**
      * Update the TXOP end timer when starting a frame transmission.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-operation.cc ns-3.43/src/wifi/model/eht/eht-operation.cc
--- ns-3.42/src/wifi/model/eht/eht-operation.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-operation.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sharan Naribole <sharan.naribole@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-operation.h ns-3.43/src/wifi/model/eht/eht-operation.h
--- ns-3.42/src/wifi/model/eht/eht-operation.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-operation.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2022
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sharan Naribole <sharan.naribole@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-phy.cc ns-3.43/src/wifi/model/eht/eht-phy.cc
--- ns-3.42/src/wifi/model/eht/eht-phy.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-phy.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -337,17 +326,17 @@
 }
 
 uint64_t
-EhtPhy::GetPhyRate(uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+EhtPhy::GetPhyRate(uint8_t mcsValue, MHz_u channelWidth, Time guardInterval, uint8_t nss)
 {
-    WifiCodeRate codeRate = GetCodeRate(mcsValue);
-    uint64_t dataRate = GetDataRate(mcsValue, channelWidth, guardInterval, nss);
+    const auto codeRate = GetCodeRate(mcsValue);
+    const auto dataRate = GetDataRate(mcsValue, channelWidth, guardInterval, nss);
     return HtPhy::CalculatePhyRate(codeRate, dataRate);
 }
 
 uint64_t
 EhtPhy::GetPhyRateFromTxVector(const WifiTxVector& txVector, uint16_t staId /* = SU_STA_ID */)
 {
-    uint16_t bw = txVector.GetChannelWidth();
+    auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
         bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
@@ -361,7 +350,7 @@
 uint64_t
 EhtPhy::GetDataRateFromTxVector(const WifiTxVector& txVector, uint16_t staId /* = SU_STA_ID */)
 {
-    uint16_t bw = txVector.GetChannelWidth();
+    auto bw = txVector.GetChannelWidth();
     if (txVector.IsMu())
     {
         bw = HeRu::GetBandwidth(txVector.GetRu(staId).GetRuType());
@@ -373,11 +362,12 @@
 }
 
 uint64_t
-EhtPhy::GetDataRate(uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+EhtPhy::GetDataRate(uint8_t mcsValue, MHz_u channelWidth, Time guardInterval, uint8_t nss)
 {
-    NS_ASSERT(guardInterval == 800 || guardInterval == 1600 || guardInterval == 3200);
+    [[maybe_unused]] const auto gi = guardInterval.GetNanoSeconds();
+    NS_ASSERT((gi == 800) || (gi == 1600) || (gi == 3200));
     NS_ASSERT(nss <= 8);
-    return HtPhy::CalculateDataRate(GetSymbolDuration(NanoSeconds(guardInterval)),
+    return HtPhy::CalculateDataRate(GetSymbolDuration(guardInterval),
                                     GetUsableSubcarriers(channelWidth),
                                     static_cast<uint16_t>(log2(GetConstellationSize(mcsValue))),
                                     HtPhy::GetCodeRatio(GetCodeRate(mcsValue)),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-phy.h ns-3.43/src/wifi/model/eht/eht-phy.h
--- ns-3.42/src/wifi/model/eht/eht-phy.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-phy.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -192,15 +181,15 @@
      * and is mainly used as a callback for WifiMode operation.
      *
      * \param mcsValue the EHT MCS index
-     * \param channelWidth the considered channel width in MHz
-     * \param guardInterval the considered guard interval duration in nanoseconds
+     * \param channelWidth the considered channel width
+     * \param guardInterval the considered guard interval duration
      * \param nss the considered number of stream
      *
      * \return the physical bit rate of this signal in bps.
      */
     static uint64_t GetPhyRate(uint8_t mcsValue,
-                               uint16_t channelWidth,
-                               uint16_t guardInterval,
+                               MHz_u channelWidth,
+                               Time guardInterval,
                                uint8_t nss);
 
     /**
@@ -232,14 +221,14 @@
      * streams.
      *
      * \param mcsValue the EHT MCS index
-     * \param channelWidth the channel width in MHz
-     * \param guardInterval the guard interval duration in nanoseconds
+     * \param channelWidth the channel width
+     * \param guardInterval the guard interval duration
      * \param nss the number of spatial streams
      * \return the data bit rate in bps.
      */
     static uint64_t GetDataRate(uint8_t mcsValue,
-                                uint16_t channelWidth,
-                                uint16_t guardInterval,
+                                MHz_u channelWidth,
+                                Time guardInterval,
                                 uint8_t nss);
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-ppdu.cc ns-3.43/src/wifi/model/eht/eht-ppdu.cc
--- ns-3.42/src/wifi/model/eht/eht-ppdu.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-ppdu.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -171,7 +160,7 @@
 }
 
 std::pair<std::size_t, std::size_t>
-EhtPpdu::GetNumRusPerEhtSigBContentChannel(uint16_t channelWidth,
+EhtPpdu::GetNumRusPerEhtSigBContentChannel(MHz_u channelWidth,
                                            uint8_t ehtPpduType,
                                            const RuAllocation& ruAllocation,
                                            bool compression,
@@ -200,7 +189,7 @@
 }
 
 uint32_t
-EhtPpdu::GetEhtSigFieldSize(uint16_t channelWidth,
+EhtPpdu::GetEhtSigFieldSize(MHz_u channelWidth,
                             const RuAllocation& ruAllocation,
                             uint8_t ehtPpduType,
                             bool compression,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/eht-ppdu.h ns-3.43/src/wifi/model/eht/eht-ppdu.h
--- ns-3.42/src/wifi/model/eht/eht-ppdu.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/eht/eht-ppdu.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021 DERONNE SOFTWARE ENGINEERING
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -107,7 +96,7 @@
      * Get the number of RUs per EHT-SIG-B content channel.
      * This function will be used once EHT PHY headers are implemented.
      *
-     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param channelWidth the channel width occupied by the PPDU
      * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
      * \param compression flag whether compression mode is used by the PPDU
@@ -115,7 +104,7 @@
      * \return a pair containing the number of RUs in each EHT-SIG-B content channel (resp. 1 and 2)
      */
     static std::pair<std::size_t, std::size_t> GetNumRusPerEhtSigBContentChannel(
-        uint16_t channelWidth,
+        MHz_u channelWidth,
         uint8_t ehtPpduType,
         const std::vector<uint8_t>& ruAllocation,
         bool compression,
@@ -134,14 +123,14 @@
 
     /**
      * Get variable length EHT-SIG field size
-     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param channelWidth the channel width occupied by the PPDU
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
      * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
      * \param compression flag whether compression mode is used by the PPDU
      * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      * \return field size in bytes
      */
-    static uint32_t GetEhtSigFieldSize(uint16_t channelWidth,
+    static uint32_t GetEhtSigFieldSize(MHz_u channelWidth,
                                        const std::vector<uint8_t>& ruAllocation,
                                        uint8_t ehtPpduType,
                                        bool compression,
